require_relative 'required_files'

def pause(time)
  value = check_is_using_variable(time)
  sleep value.to_i
end

def wait_for_element_editable(element, duration)
  value = check_is_using_variable(duration)
  wait = Selenium::WebDriver::Wait.new(:timeout => value.to_i / 1000)
  wait.until { find_object(element).enabled? }
end

def wait_for_element_not_editable(element, duration)
  value = check_is_using_variable(duration)
  wait = Selenium::WebDriver::Wait.new(:timeout => value.to_i / 1000)
  wait.until { !find_object(element).enabled? }
end

def wait_for_element_not_present(element, duration)
  value = check_is_using_variable(duration)
  wait = Selenium::WebDriver::Wait.new(:timeout => value.to_i / 1000)
  wait.until do
    begin
      !find_object(element)
    rescue Selenium::WebDriver::Error::NoSuchElementError
      true
    end
  end
end

def wait_for_element_not_visible(element, duration)
  value = check_is_using_variable(duration)
  wait = Selenium::WebDriver::Wait.new(:timeout => value.to_i / 1000)
  wait.until { !find_object(element).displayed? }
end

def wait_for_text(element, text)
  value = check_is_using_variable(text)
  wait = Selenium::WebDriver::Wait.new(:timeout => 30)
  wait.until { find_object(element).text == value }
end

def wait_for_element_visible(element, duration)
  value = check_is_using_variable(duration)
  wait = Selenium::WebDriver::Wait.new(:timeout => value.to_i / 1000)
  wait.until { find_object(element).displayed? }
end

def wait_for_element_present(element, duration)
  value = check_is_using_variable(duration)
  wait = Selenium::WebDriver::Wait.new(:timeout => value.to_i / 1000)
  wait.until { find_object(element) }
end

def answer_on_next_prompt(answer)
  value = check_is_using_variable(answer)
  alert = $driver.switch_to.alert
  alert.send_keys(value)
  alert.accept()
end

def choose_cancel_on_next_confirmation
  $driver.switch_to.alert.dismiss
end

def choose_cancel_on_next_prompt
  $driver.switch_to.alert.dismiss
end

def choose_ok_on_next_confirmation
  $driver.switch_to.alert.accept
end

def webdriver_answer_on_visible_prompt(answer)
  value = check_is_using_variable(answer)
  alert = $driver.switch_to.alert
  alert.send_keys(value)
  alert.accept()
end

def webdriver_choose_cancel_on_visible_confirmation
  $driver.switch_to.alert.dismiss
end

def webdriver_choose_ok_on_visible_confirmation
  $driver.switch_to.alert.accept
end

def webdriver_choose_cancel_on_visible_prompt
  $driver.switch_to.alert.dismiss
end
